clear all
close all
clc

%% Incializace IC M-H algoritmu
S0 = 50000; %vyhozene vzorky
S1 = 50000; %ponechane vzorky
S = S0+S1;

count = 0; %pocitadlo akceptovanych vzorku
theta = zeros(1,S+1);
theta(1) = 0; %pocatecni podminka

%% Independence chain M-H algoritmus
d = 10; %smerodatna odchylka kandidatske hustoty N(0,d^2)
for s=2:S+1
   %a) generovani kandidata z N(0,d^2)
   theta_ast = randn*d; 
   
   %b) spocitani akceptacni pravdepodobnosti
   a = min(exp(-1/2*abs(theta_ast))/...
       exp(-1/2*abs(theta(s-1)))*...
       exp(-1/(2*d^2)*theta(s-1)^2)/...
       exp(-1/(2*d^2)*theta_ast^2),... 
       1);
   
   %c) rozhodnuti o akceptaci
    if a>rand
        theta(s) = theta_ast;
        count = count+1;
    else
        theta(s) = theta(s-1);
    end
end

%% Posteriorni analyza
%vyhozeni S0 vzorku
 theta(1:S0+1)=[];

%opticke vyhodnoceni konvergence
 figure
 plot(theta(1:500:end))

%vypocet momentu
E_theta = mean(theta);
D_theta = var(theta);
avg_count = count/S; %prumerna mira akceptace

%zobrazeni vysledku
fprintf('E_theta  D_theta  prumerna akceptace\n')
fprintf('%6.4f   %6.4f   %6.4f\n',E_theta,D_theta,avg_count)

%Zobrazeni empirickeho rozdeleni
figure
hist(theta,30)


